Silver Wolf #1 @8219
Fri Apr 07 18:30:10 1995
RE: Yeah!  I would prefer it pre-compiled, though...
BY: Telisis Nightmare #1 @10307

2TN> 0I'd love to have that!

I don't have a precompiled version yet(still am testing it, making sure that it
is stable..), he is some source code:

        Hello,
        This is my unofficial FAQ on making WWIVedit somewhat multitasker
aware.  It includes two different sets of code for you to try out(I didn't
write either one of them!!!!  OTHER PEOPLE WROTE THEM!).  I find the first
one is a little better, but that's just my system, so test it and find out
for your own..  I took out a few lines, so that it is a bit more WWIVedit
friendly.

Instructions for the first example:

You need to define the CONST and VAR variables in WEVARS.PAS in the correct
section.  I just added them to the bottom of CONST and VAR, respectively.

Then in WWIVEDIT.PAS add the procedures to the top.  The go down to the main
program, and place the get_xxx_version at the top under "Setup".

Then under "ShowHeader;", I placed giveup_timeslice;, but I suppose you can
add that anywhere.

I don't have instructions for the second, as I took it out of my source,
not really bothering with what went where, but its pretty straight forward.


I am by no means a PASCAL programmer, I've just figured this stuff out by
trial and error, so I leave it up to you to do the same..  I can't exactly
explain what I did.  If people would like, I can compile a special version
of WWIVedit with the timeslicing code in it and release, but I don't really
see that happening unless I get alot of requests, as 2.6 is supposed to be
a bit more multitasker friendly, and I don't want to undermine WWIV Software
Services.

This is meant to be only a temp. fix until 2.6 comes out, as I understand that
it will be quite alot better(except you don't get the source :( ).  Hope
you find this little bit of info helpful, if you do, then please let me know,
if not, then please let me know:
1@8219.WWIVnet
1@3104.IceNet
1@3119.TerraNET
1@71.DigiNET
Perry Wolf (1:109/567)@fidonet
Perry Wolf (81:125/53)@os2net
PerryWolf@aol.com
1-8219@wwivnet.org
1-3119@tnet.bt.quake.com

giveup_timeslice() ported to Turbo Pascal
Nowhere Fast #258 @8412
Tue Mar 28 11:11:17a 1995
RE: YEa...
BY: Silver Wolf #1 @8219

/* give up time slices in OS/2, Windows, and DV */
/* ported from C by 1@8000, Nowhere Fast */
const
  mt_windows : boolean = false;
  mt_os2     : boolean = false;
  mt_dv      : boolean = false;

var
  osmajor, osminor : byte;

procedure get_dos_version;
begin
  asm
    mov   ax,3000h
    int   21h
    mov   osmajor,al
    mov   osminor,ah
  end;
  if (osmajor >= 10)
    then begin
      mt_os2 := true;
      osmajor := osmajor div 10;
    end;
end;

procedure get_win_version;
var ver : word;
begin
  ver := 0;
  asm
    push  bp
    push  es
    push  bx
    mov   ax,352fh
    int   21h
    mov   ax,es
    or    ax,bx
    jz    @no_windows
    mov   ax,1600h
    int   2fh
    mov   ver,ax
@no_windows:
    pop   bx
    pop   es
    pop   bp
  end;
  if (ver mod 256 <= 1)
    then ver := 0;
  if (ver <> 0) then begin
    mt_windows := true;
    osmajor := ver mod 256;
    osminor := ver div 256;
  end;
end;

procedure get_dv_version;
var rc : byte;
    ver : word;
begin
  asm
    mov   ax,2b01h
    mov   cx,4445h
    mov   dx,5351h
    int   21h
    mov   ver,bx
    mov   rc,al
  end;
  if (rc = $ff)
    then ver := 0
    else begin
      mt_dv := true;
      osmajor := ver div 256;
      osminor := ver mod 256;
    end;
end;

procedure giveup_timeslice;
begin
  if (mt_os2 or mt_windows) then
    asm
      push  bp
      mov   ax,1680h
      int   2fh
      pop   bp
    end
  else if mt_dv then
    asm
      mov   ax,101ah
      int   15h
      mov   ax,1000h
      int   15h
      mov   ax,1025h
      int   15h
    end;
end;

begin
  get_dos_version;
  get_win_version;
  get_dv_version;
end.






{
From: FRED COHEN
      Time Slices...

looking for routines for giving up time slices to
various multi-taskers, mainly DV and OS/2.  Please either
post them if they are small enough, or tell me where I can

You will need turbo pascal 6.0+ for this to compile.  It is easy to
convert over to regular pascal though.
}

Const

  MDOS = 0;  { DOS               }
  OS2  = 1;  { OS/2 is installed }
  WIN  = 2;  { Windoze           }
  DV   = 3;  { DesqView          }

Var

  Ops            : Byte;    { Operating System OS/2/DOS/WIN/DV}


PROCEDURE giveslice; Assembler; {Gives up remainder of clock cycle
                                 under dos, windows, os/2 }
  asm
    CMP ops,MDos { Compare to DOS }
    JE @MSDOS    { Jump if = }
    CMP ops,Dv   { Compare to Desqview }
    JE @DESQVIEW { Jump if = }
    CMP ops, Win { Compare to Windows }
    JE @WINOS2   { Jump if = }
    CMP ops, OS2 { Compart OS/2 }
    JE @WINOS2   { Jump if = }
    JMP @NONE    { None found, Jump to End }


 @MSDOS:
    INT 28h   { Interupt 28h }
    JMP @NONE { Jump to the end }

 @DESQVIEW:
    MOV ax,1000h { AX = 1000h }
    INT 15h      { Call Interupt 15h }
    JMP @NONE    { Jump to the end }

 @WINOS2:
    MOV AX, 1680h { AX = 1680h }
    INT 2Fh       { Call Interupt 2Fh for Win-OS/2 TimeSlice }

 @NONE:

end; {GiveSlice}

{***********}

PROCEDURE checkos; Assembler;
{ Currently Supports DesqView, Microsoft Windows and IBM's OS/2 }

asm
  mov ops, MDos { Default DOS }
  mov ah, 30h   { AH = 30h }
  int 21h  { dos version }
  cmp al, 14h
  jae @IBMOS2 { Jump if >= to 20 }


  mov ax,2B01h
  mov cx,4445h
  mov dx,5351h
  int 21h { Desqview Installed? }
  cmp al, 255
  jne @DesqView { Jump if AL <> 255 }

  mov ax,160Ah
  int 2Fh { Windows Install?}
  cmp ax, 0h
  je @Windows { If = Jump to Windows }
  jmp @Finish { Nothing found, go to the end }

@IBMOS2:
  mov Ops, Os2  { Set OS Value }
  jmp @Finish

@DesqView:
  mov ops, Dv   { Set OS Value }
  jmp @Finish

@Windows:
  mov ops, win  { Set OS Value }
  jmp @Finish

@FINISH:
end; { checkos }

{***********  MORE  ********}

procedure GiveTimeSlice;  ASSEMBLER;
asm     { GiveTimeSlice }
  cmp   MultiTasker, DesqView
  je    @DVwait
  cmp   MultiTasker, Windows
  je    @WinOS2wait
  cmp   MultiTasker, OS2
  je    @WinOS2wait
  cmp   MultiTasker, NetWare
  je    @Netwarewait
  cmp   MultiTasker, DoubleDOS
  je    @DoubleDOSwait

@Doswait:
  int   $28
  jmp   @WaitDone

@DVwait:
  mov   AX, $1000
  int   $15
  jmp   @WaitDone

@DoubleDOSwait:
  mov   AX, $EE01
  int   $21
  jmp   @WaitDone

@WinOS2wait:
  mov   AX, $1680
  int   $2F
  jmp   @WaitDone

@Netwarewait:
  mov   BX, $000A
  int   $7A

@WaitDone:
end;    { TimeSlice }


               9 1SW 90

------
Before you louse something up, THIMK!
